//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  LŐÓIz^̃f[^
// 1 ̐ÓIz
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2020N0910 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE5(UP2) Pro VCL-32
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  plCommMem;

{$R *.dfm}

const
  MAPNAME = 'TEST_1dimArray-Double_MEMORY_MAPPED_FILE_NAME';
  MAPSISE = 4096 * 10000;

  FColCount = 5;

type
  TDoubleArray = array [0..FColCount - 1] of Double;

//=============================================================================
//  tH[̏
//  L̐
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  // \ȃTCY̋Lm
  TplCommMem.Create(MAPSISE, MAPNAME);

  Memo1.ScrollBars := ssVertical;
  Memo1.Font.Size  := 11;
  Memo1.Font.Name  := 'Courier New';
end;

//=============================================================================
//  tH[j̏
//  L̉
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  TplCommMem.Free(MAPNAME);
end;

//=============================================================================
//  LɃe[^
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LSrcDblArray : TDoubleArray;
  LCol         : Integer;
  LInfoArray   : TCommMemHeaderArray;
  LMemStream   : TMemoryStream;
begin
  // eXgp̃f[^zvfɑ
  for LCol := 0 to FColCount - 1 do begin
    LSrcDblArray[LCol] := 100 + (LCol + 1) / 10.0;
  end;

  // L̃wb_
  WriteCommMemHeader(MAPNAME, LInfoArray, 1);


  LMemStream := TMemoryStream.Create;
  try
    // Xg[ɔzf[^i[
    LMemStream.Size := FColCount * SizeOf(Double);
    LMemStream.Write(@LSrcDblArray, LMemStream.Size);

    // zf[^i[Xg[Lɏ
    WriteCommMemData(MAPNAME, LMemStream, LInfoArray, '1dimArray-Double');
  finally
    FreeAndNil(LMemStream);
  end;
end;

//=============================================================================
//  Lf[^擾
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
var
  LDataCount   : Cardinal;
  LInfoArray   : TCommMemHeaderArray;
  LMemStream   : TMemoryStream;
  LDataType    : string;
  LDstDblArray : TDoubleArray;
  LCol         : Integer;
  LResText     : string;
begin
  Memo1.Lines.Clear;

  // L̃wb_擾
  if not ReadCommMemHeader(MAPNAME, LInfoArray, LDataCount) then Exit;
  if (LDataCount = 0) then Exit;


  LMemStream := TMemoryStream.Create;
  try
    // L̃f[^Xg[ɓǂݏo
    ReadCommMemData(MAPNAME, LMemStream, LInfoArray, 0, LDataType);

    if LDataType = '1dimArray-Double' then begin
      // Xg[̃f[^zvfɓǂݍ
      LMemStream.Position := 0;
      LMemStream.Read(LDstDblArray, LMemStream.Size);

      // 擾f[^\
      LResText := '';
      for LCol := 0 to FColCount - 1 do begin
        LResText := LResText + FormatFloat('   000.0', LDstDblArray[LCol]);
      end;
      Memo1.Lines.Add(LResText);
    end;
  finally
    FreeAndNil(LMemStream);
  end;
end;

end.
