//=============================================================================
//  L 2 ̓Iz^̃f[^
//  TplCommMem ̋@\gp
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2020N0910 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE5(UP2) Pro VCL-32
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  plCommMem;

{$R *.dfm}

const
  MAPNAME = '2DIM-DYNARRAY-INTEGER_MEMORY_MAPPED_FILE_NAME';
  MAPSISE = 4096 * 10000;

type
  TInteger2dimDynArray = array of array of Integer;

  TDynArrayHeader = record
    RowCount : Integer;
    ColCount : Integer;
  end;


//=============================================================================
//  tH[̏
//  L̐
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  // \ȃTCY̋Lm
  TplCommMem.Create(MAPSISE, MAPNAME);

  Memo1.ScrollBars := ssVertical;
  Memo1.Font.Size  := 11;
  Memo1.Font.Name  := 'Courier New';
end;

//=============================================================================
//  tH[j̏
//  L̉
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  TplCommMem.Free(MAPNAME);
end;

//=============================================================================
//  L 2 ̓Iz^̃f[^
//  TplCommMem ̋@\gp
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
const
  LRowCount : Integer = 2;
  LColCount : Integer = 5;
var
  LSrcIntArray : TInteger2dimDynArray;
  LHeaderInfo  : TDynArrayHeader;
  LOffset      : Cardinal;
  LRowSize     : Cardinal;
  LRow         : Integer;
  LCol         : Integer;
begin
  SetLength(LSrcIntArray, LRowCount, LColCount);
  for LRow := 0 to LRowCount - 1 do begin
    for LCol := 0 to LColCount - 1 do begin
      LSrcIntArray[LRow][LCol] := (LRow + 1) * 1000 + (LCol + 1);
    end;
  end;

  LHeaderInfo.RowCount := LRowCount;
  LHeaderInfo.ColCount := LColCount;
  TplCommMem.Write(MAPNAME, @LHeaderInfo, 0, SizeOf(LHeaderInfo));

  LRowSize := LColCount * SizeOf(Integer);
  for LRow := 0 to LRowCount - 1 do begin
    LOffset := SizeOf(LHeaderInfo) + LRow * LRowSize;
    TplCommMem.Write(MAPNAME, @LSrcIntArray[LRow][0], LOffset, LRowSize);
  end;
end;

//=============================================================================
//  L 2 ̓Iz^̃f[^ǂݏo
//  TplCommMem ̋@\gp
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
var
  LDstIntArray : TInteger2dimDynArray;
  LHeaderInfo  : TDynArrayHeader;
  LOffset      : Cardinal;
  LRowSize     : Cardinal;
  LRow         : Integer;
  LCol         : Integer;
  LResText     : string;
begin
  Memo1.Lines.Clear;

  TplCommMem.Read(MAPNAME, @LHeaderInfo, 0, SizeOf(LHeaderInfo));

  SetLength(LDstIntArray, LHeaderInfo.RowCount, LHeaderInfo.ColCount);

  LRowSize := LHeaderInfo.ColCount * SizeOf(Integer);
  for LRow := 0 to LHeaderInfo.RowCount - 1 do begin
    LOffset := SizeOf(LHeaderInfo) + LRow * LRowSize;
    TplCommMem.Read(MAPNAME, @LDstIntArray[LRow][0], LOffset, LRowSize);
  end;

  for LRow := 0 to LHeaderInfo.RowCount - 1 do begin
    LResText := '';
    for LCol := 0 to LHeaderInfo.ColCount - 1 do begin
      LResText := LResText + FormatFloat('   0000', LDstIntArray[LRow][LCol]);
    end;
    Memo1.Lines.Add(LResText);
  end;
end;

end.
