//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  }bvht@C (t@C}bsO) ɂ鋤L̍쐬Ƒ
//  L̃e[^p\bh
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2020N0910 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE5(UP22) Pro VCL-32
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plCommMem;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Classes, Vcl.Dialogs;

type
  // f[^R[h^ɂĂ 
  TCommMemFileHeader = record
    Count : Integer;  // f[^
  end;

  TCommMemHeader = record
    Offset : Cardinal;              // 񂾈ʒui擪̃ItZbgoCgj
    Size : Cardinal;                // f[^̃oCg
    dType : array[0..32] of Char;   // f[^̌` ()Di[e͔C
  end;
  PCommMemHeader = ^TCommMemHeader;

  // ̃R[h^̓Iz
  TCommMemHeaderArray = array of TCommMemHeader;
  PCommMemHeaderArray = ^TCommMemHeaderArray;

  PplCommMem = ^TplCommMem;
  TplCommMem = record
  private
    class var
      FhCommMem : THandle;
    class procedure Open(var hMutex: THandle; var hMapObject: THandle;
      var pBaseAddr: Pointer; MapFileName: string); static;
    class procedure Close(hMutex: THandle; hObject: THandle; pBaseAddr: Pointer); static;
  public
    class procedure Create(AllocSize: DWORD; MapFileName: string); static;
    class procedure Free(MapFileName: string); static;
    class function Write(MapFileName: string; Source: Pointer; Offset: DWORD;
      Length: DWORD): Boolean; static;
    class function Read(MapFileName: string; Destination: Pointer; Offset: DWORD;
      Length: DWORD): Boolean; static;
    class function Size(MapFileName: string): NativeUInt; static;
  end;

  // ȉ͋Lŕ̃f[^ꍇ̊֐
  // ̊֐ނ TplCommMem ł͎gpĂȂ 
  function WriteCommMemHeader(AMapName: string; var AInfoArray: TCommMemHeaderArray;
    ADataCount: Cardinal): Boolean;
  function WriteCommMemData(AMapName: string; ASrcStream: TMemoryStream;
    var AInfoArray: TCommMemHeaderArray; ADataType: string): Boolean;
  function ReadCommMemHeader(AMapName: string; var AInfoArray: TCommMemHeaderArray;
    var ADataCount: Cardinal): Boolean;
  function ReadCommMemData(AMapName: string; ADstStream: TMemoryStream;
    AInfoArray: TCommMemHeaderArray; AIndex: Integer; var ADataType: string):
    Boolean;
  function StringToMemStream(AText: string; ADstStream: TMemoryStream): Boolean;
  function MemStreamToString(ASrcStream: TMemoryStream): string;

implementation

var
  FErrorText : string;
const
  // ǉ֐ނŎgp萔l
  // ̒l TCommMemXXX R[h^ TplCommMem ł͎gpĂȂ
  FFileHeaderSize : Cardinal = SizeOf(TCommMemFileHeader);
  FInfoHeaderSize : Cardinal = SizeOf(TCommMemHeader);

{ TplCommMem }

//=============================================================================
//  Ot}bvht@CgpL̍쐬
//
//  AllocSize   : mۂ鋤L (}bvht@C) ̃TCY (oCg)
//  MapFileName : L (}bvht@C)
//
//   MapFileName ̃}bvht@C݂ꍇCVK쐬͂Ȃ
//  ̏ꍇCG[l ERROR_ALREADY_EXISTS ƂȂ
//
//  }bvht@C̃TCÝCy[WTCY (4 KB) PʂŎw肷
//  y[WTCY̔{lłȂꍇ͎
//=============================================================================
class procedure TplCommMem.Create(AllocSize: DWORD; MapFileName: string);
begin
  FhCommMem:= CreateFileMapping(INVALID_HANDLE_VALUE,
                                nil,
                                PAGE_READWRITE,
                                0,
                                AllocSize,
                                PChar(MapFileName));
end;

//=============================================================================
//  Lj
//  L̃}bvht@C̔j́C쐬AvłȂƂłȂ
//=============================================================================
class procedure TplCommMem.Free(MapFileName: string);
var
  LhMapObj : THandle;
begin
  LhMapObj:= OpenFileMapping(FILE_MAP_ALL_ACCESS, False, PChar(MapFileName));
  if LhMapObj <> 0 then begin
    CloseHandle(LhMapObj);
    CloseHandle(FhCommMem);
    FhCommMem := 0;
  end;
end;

//=============================================================================
//  LɃf[^
//
//  MapFileName : }bvht@C̖O ( L̖O )
//  Source      : Lɏރf[^̃AhX
//  Offset      : f[^݊Jn鋤L̐擪̈ʒu (oCgP)
//  Length      : Lɏރf[^̃oCgTCY  
//=============================================================================
class function TplCommMem.Write(MapFileName: string; Source: Pointer;
  Offset: DWORD; Length: DWORD): Boolean;
var
  LhMutex     : THandle;
  LhMapObj    : THandle;
  LpBaseAddr  : Pointer;
  LMemoryInfo : MEMORY_BASIC_INFORMATION;
begin
  Result := False;

  Open(LhMutex, LhMapObj, LpBaseAddr, MapFileName);
  if LhMapObj <> 0 then begin
    VirtualQuery(LpBaseAddr, LMemoryInfo, SizeOf(LMemoryInfo));
    if (Offset + Length) < LMemoryInfo.RegionSize then begin
     // ~[ebNXIuWFNg̏Ԃ`FbN
     // ̎͑҂
      WaitForSingleObject(LhMutex, INFINITE);
      // f[^
      CopyMemory(Pointer(NativeUInt(LpBaseAddr) + Offset), Source, Length);
      // tbVĊmɍXV
      FlushViewOfFile(Pointer(NativeUInt(LpBaseAddr) + Offset), Length);
      Result := True;
    end else begin
      // ݃TCYI[o[
    end;
  end;
  Close(LhMutex, LhMapObj, LpBaseAddr);
end;

//=============================================================================
//  Lf[^ǂݏo
//
//  MapFileName : }bvht@C̖O ( L̖O )
//  Destination : Lǂݍ񂾃f[^̊i[AhX
//  Offset      : f[^ǂݏoL̐擪̈ʒu (oCgP)
//  Length      : Lǂݍރf[^̃oCgTCY
//=============================================================================
class function TplCommMem.Read(MapFileName: string; Destination: Pointer;
  Offset: DWORD; Length: DWORD): Boolean;
var
  LhMutex     : THandle;
  LhMapObj    : THandle;
  LpBaseAddr  : Pointer;
  LMemoryInfo : MEMORY_BASIC_INFORMATION;
begin
  Result := False;

  Open(LhMutex, LhMapObj, LpBaseAddr, MapFileName);
  if LhMapObj <> 0 then begin
    VirtualQuery(LpBaseAddr, LMemoryInfo, SizeOf(LMemoryInfo));
    if (Offset + Length) < LMemoryInfo.RegionSize then begin
     // ~[ebNXIuWFNg̏Ԃ`FbN
     // ̎͑҂
      WaitForSingleObject(LhMutex, INFINITE);
      // f[^ǂݏo
      CopyMemory(Destination, Pointer(NativeUInt(LpBaseAddr) + Offset), Length);
      Result := True;
    end else begin
      // ǂݏoTCYI[o[
    end;
  end else begin
    ZeroMemory(Destination, Length);
  end;
  Close(LhMutex, LhMapObj, LpBaseAddr);
end;

//=============================================================================
//  L (}buht@C) ̃oCgTCg擾
//=============================================================================
class function TplCommMem.Size(MapFileName: string): NativeUInt;
var
  LhMutex     : THandle;
  LhMapObj    : THandle;
  LpBaseAddr  : Pointer;
  LMemoryInfo : MEMORY_BASIC_INFORMATION;
begin
  Result := 0;

  Open(LhMutex, LhMapObj, LpBaseAddr, MapFileName);
  if LhMapObj <> 0 then begin
    VirtualQuery(LpBaseAddr, LMemoryInfo, SizeOf(LMemoryInfo));
    Result := LMemoryInfo.RegionSize;
  end;
  Close(LhMutex, LhMapObj, LpBaseAddr);
end;

//=============================================================================
//  ~[ebNXIuWFNg𐶐
//  }buht@CJ
//=============================================================================
class procedure TplCommMem.Open(var hMutex: THandle; var hMapObject: THandle;
  var pBaseAddr: Pointer; MapFileName: string);
var
  LMutexName : string;
begin
  hMapObject := 0;
  // ~[ebNXIuWFNg𐶐
  LMutexName := MapFileName + '_Mutex';
  hMutex := CreateMutex(nil, False, PChar(LMutexName));
  if hMutex = 0 then Exit;

  // }buht@C̃nh擾
  hMapObject := OpenFileMapping(FILE_MAP_ALL_ACCESS, False, PChar(MapFileName));
  if hMapObject <> 0 then begin
    // L̐擪AhX̃|C^擾
    pBaseAddr := MapViewOfFile(hMapObject, FILE_MAP_ALL_ACCESS, 0, 0, 0);
  end;
end;

//=============================================================================
//  }buht@C
//  ~[ebNXIuWFNg̏L̔jƃnh̊J
//=============================================================================
class procedure TplCommMem.Close(hMutex: THandle; hObject: THandle; pBaseAddr: Pointer);
begin
  if hObject <> 0 then begin
   UnmapViewOfFile(pBaseAddr);
    CloseHandle(hObject);
  end;

  // ~[ebNXIuWFNg̏L̔jƃnh̊J
  if hMutex <> 0 then begin
    ReleaseMutex(hMutex);
    CloseHandle(hMutex);
  end;
end;

//-----------------------------------------------------------------------------
//  f[^̏擾ăR[h^̃o̒l𒲂ׂ
//  WriteCommMemHeader sĂΏ 0 ɂȂĂ
//-----------------------------------------------------------------------------
function CheckInfoHeader(AMapName: string; AIndex: Integer): Boolean;
var
  LInfoHeader : TCommMemHeader;
  LInfoOffset : Cardinal;
begin
  // f[^i[ẴR[h^̒lǂݏo
  LInfoOffset := FFileHeaderSize + Cardinal(AIndex) * FInfoHeaderSize;
  TplCommMem.Read(AMapName,
                 @LInfoHeader,
                 LInfoOffset,
                 FInfoHeaderSize);
  Result := (LInfoHeader.Offset > 0) and (LInfoHeader.Offset > 0);
end;

//-----------------------------------------------------------------------------
//  TplCommMem 𗘗pĕf[^Lɏނ߂̊֐
//  L̃wb_̏
//  WriteCommMemDat ֐Ńf[^ޑOɂ̊֐s
//
//  AMapName        : L
//  var AInfoArray  : f[^̏i[ TCommMemHeader;R[h^̓Iz
//  ADataCount      : z̗vfD̒lf[^
//-----------------------------------------------------------------------------
function WriteCommMemHeader(AMapName: string; var AInfoArray: TCommMemHeaderArray;
  ADataCount: Cardinal): Boolean;
var
  LFileHeader : TCommMemFileHeader;
  LMemStream  : TMemoryStream;
  LMemSize    : Cardinal;
begin
  Result := False;

  if (ADataCount <= 0) then begin
    FErrorText := 'z̗vf 1 ȏKvłD';
    MessageBox(0, PChar(FErrorText), '', MB_ICONWARNING);
    Exit;
  end;

  // z̗vfݒ
  SetLength(AInfoArray, ADataCount);

  // wb_̗p
  LMemStream := TMemoryStream.Create;
  try
    LMemSize := FFileHeaderSize + Cardinal(Length(AInfoArray)) * FInfoHeaderSize;
    if (LMemSize > TplCommMem.Size(AMapName)) then begin
      FErrorText := 'ރTCYL̃TCYzĂ܂D';
      MessageBox(0, PChar(FErrorText), '', MB_ICONWARNING);
      Exit;
    end;

    LMemStream.Size := LMemSize;
    ZeroMemory(LMemStream.Memory, LMemSize);
    Result := Tplcommmem.Write(AMapName, LMemStream.Memory, 0, LMemSize);
  finally
    FreeAndNil(LMemStream);
  end;
  if not Result then begin
    FErrorText := 'LɃANZXł܂D' + sLineBreak
                +  'w薼̋L쐬ĂȂ\܂D';
    MessageBox(0, PChar(FErrorText), '', MB_ICONWARNING);
    Exit;
  end;

  // L̐擪Ƀf[^R[h^Ƃď
  LFileHeader.Count := ADataCount;
  Result := TplCommMem.Write(AMapName, @LFileHeader, 0, FFileHeaderSize);
end;

//-----------------------------------------------------------------------------
//  TplCommMem 𗘗pĕf[^Lɏނ߂̊֐
//  f[^ފ֐
//  ۂɏނ͈̂ TMemoryStream ̃f[^ 
//  ރf[^ TMemoryStream Ɋi[Kv
//
//  AMapName        : L
//  ASrcStream      : Lɏރf[^i[Ă郁Xg[
//  var AInfoArray  : f[^̏i[ TCommMemHeader;R[h^̓Iz
//                    ̃oɒlZbgċLɃf[^
//  ADataType       : f[^̌`De͔C
//
//  L̃wb_̂Ƀf[^
//  ̊֐sxɏԂɃV[PVɃf[^ł
//-----------------------------------------------------------------------------
function WriteCommMemData(AMapName: string; ASrcStream: TMemoryStream;
  var AInfoArray: TCommMemHeaderArray; ADataType: string): Boolean;
{$WRITEABLECONST ON}
const
  LIndex      : Integer = 0;
  LDataCount  : Integer = 0;
  LDataOffset : Cardinal = 0;
{$WRITEABLECONST OFF}
var
  LInfoOffset : Cardinal;
begin
  Result := False;
  
  if Length(AInfoArray) <= 0 then begin
    FErrorText := 'z̗vfݒ肳Ă܂D';
    MessageBox(0, PChar(FErrorText), '', MB_ICONWARNING);
    Exit;
  end;

  // ŏ̃f[^i[ẴR[h^̒l`FbN
  if not CheckInfoHeader(AMapName, 0) then LIndex := 0;
  if LIndex = 0 then begin
    // ŏ̃f[^݂̏̎̏
    // wb_f[^ǂݏo
    Result := TplcommMem.Read(AMapName, @LDataCount, 0, FFileHeaderSize);
    // ŏ̃f[^ދL̈ʒu
    LDataOffset := FFileHeaderSize + cardinal(LDataCount) * FInfoHeaderSize;
  end;
  // e[^̏i[郌R[h^̃f[^݈̏ʒu
  LInfoOffset := FFileHeaderSize + Cardinal(LIndex) * FInfoHeaderSize;

  if LDataCount <> Length(AInfoArray) then begin
    FErrorText := 'f[^͓rύXł܂D';
    MessageBox(0, PChar(FErrorText), '', MB_ICONWARNING);
    Exit;
  end;
  if LIndex > High(AInfoArray) then begin
    FErrorText := 'ރf[^z̗vf𒴂Ă܂D';
    MessageBox(0, PChar(FErrorText), '', MB_ICONWARNING);
    Exit;
  end;
  if ((LInfoOffset + FInfoHeaderSize) > TplCommMem.Size(AMapName))
      or ((LDataOffset + ASrcStream.Size) > TplCommMem.Size(AMapName)) then begin
    FErrorText := 'ރTCYL̃TCYzĂ܂D';
    MessageBox(0, PChar(FErrorText), '', MB_ICONWARNING);
    Exit;
  end;

  // e[^̏eoɐݒ肵ăR[h^̃f[^
  AInfoArray[LIndex].Offset := LDataOffset;
  AInfoArray[LIndex].Size   := ASrcStream.Size;
  // ÓIz̗vfS Null ɂ String ^̕
  FillChar(AInfoArray[LIndex].dType[0], SizeOF(AInfoArray[LIndex].dType), #0);
  StrPCopy(AInfoArray[LIndex].dType, ADataType);
  Result := TplCommMem.Write(AMapName,
                             @AInfoArray[LIndex],
                             LInfoOffset,
                             FInfoHeaderSize);
  if Result then begin
    // TMemoryStream ̃f[^Lɏ
    Result := TplCommMem.Write(AMapName,
                               ASrcStream.Memory,
                               LDataOffset,
                               ASrcStream.Size);
    if Result then begin
      // ̃f[^݈̏ʒu
      LDataOffset := LDataOffset + ASrcStream.Size;
      // ̓Iz̗vfԍ
      LIndex := LIndex + 1;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  Lwb_̃f[^擾֐
//  wb_ɂ͋Lɏ񂾃f[^
//  ef[^̏i[R[h^̃f[^f[^
//  ۂ̃f[^͂̃wb_̌ɏ܂Ă
//
//  AMapName      @: L
//  var AInfoArray : f[^̏i[ TCommMemHeader;R[h^̓Iz
//                   ̊֐͂̃f[^Ǝ̈̒l擾
//  ar ADataCount@: f[^
//-----------------------------------------------------------------------------
function ReadCommMemHeader(AMapName: string; var AInfoArray: TCommMemHeaderArray;
  var ADataCount: Cardinal): Boolean;
var
  LFileHeader : TCommMemFileHeader;
  LInfoSize   : Integer;
begin
  ADataCount := 0;

  // L̐擪f[^̒lR[h^Ƃēǂݏo
  Result := TplCommMem.Read(AMapName, @LFileHeader, 0, FFileHeaderSize);

  if not Result then begin
    FErrorText := 'LɃANZXł܂D' + sLineBreak
                +  'w薼̋L쐬ĂȂ\܂D';
    MessageBox(0, PChar(FErrorText), '', MB_ICONWARNING);
    Exit;
  end;

  ADataCount := LFileHeader.Count;
  // Iz̗vfݒ
  SetLength(AInfoArray, ADataCount);

  // f[^̏i[Ă郌R[h^̃f[^Sēǂݍ
  // LInfoSize ̓e[^̏i[Ă郌R[h^̑SoCg
  // IźC1 ł΍ŏ̗vf̃AhXwœǂݍ߂
  // Iz̍ŏ̗vfԍ͏ 0
  LInfoSize := ADataCount * FInfoHeaderSize;
  Result := TplCommMem.Read(AMapName, @AInfoArray[0], FFileHeaderSize, LInfoSize);

  // ŏ̃f[^i[ẴR[h^̒l`FbN
  if not CheckInfoHeader(AMapName, 0) then begin
    FErrorText := 'wb_ɏ񂪂܂D';
    MessageBox(0, PChar(FErrorText), '', MB_ICONWARNING);
    Exit;
  end;
end;

//-----------------------------------------------------------------------------
//   TplCommMem 𗘗pĕf[^񂾋Lf[^ǂݍފ֐
//  ۂɂ͈ TMemoryStream ɓǂݍ 
//
//  AMapName      @: L
//  ADstStream    @: ̃Xg[ɋLǂݏof[^i[
//  var AInfoArray : f[^̏i[ TCommMemHeader;R[h^̓Iz
//                   ̊֐sO ReadCommMemHeader ֐sƎ擾ł
//  AIndex        : f[^̏i[ TCommMemHeader R[h^̓Iz̗vfԍ
//                  ̗vfԍ̃f[^ TMemoryStream Ɋi[
//  var ADataType : ǂݏof[^̌`
//-----------------------------------------------------------------------------
function ReadCommMemData(AMapName: string; ADstStream: TMemoryStream;
  AInfoArray: TCommMemHeaderArray; AIndex: Integer; var ADataType: string): Boolean;
begin
  Result := False;

  if (AIndex < 0) or (AIndex > High(AInfoArray)) then begin
    FErrorText := 'z̗vfԍ͈͊OłD';
    MessageBox(0, PChar(FErrorText), '', MB_ICONWARNING);
    Exit;
  end;

  if not CheckInfoHeader(AMapName, AIndex) then begin
    FErrorText := 'vf ' + IntToStr(AIndex)
                + ' (  ' + IntToStr(AIndex + 1) + ' Ԗ ) ̃f[^܂D';
    MessageBox(0, PChar(FErrorText), '', MB_ICONWARNING);
    Exit;
  end;

  ADataType :=  AInfoArray[AIndex].dType;
  ADstStream.Size := AInfoArray[AIndex].Size;
  Result := TplCommMem.Read(AMapName,
                            ADstStream.Memory,
                            AInfoArray[AIndex].Offset,
                            AInfoArray[AIndex].Size);
  ADstStream.Position := 0;
end;

//-----------------------------------------------------------------------------
//  String ^̕Xg[Ɋi[֐
//
//  Ƃ
//  Create ŐIuWFNg͊֐̖߂lɂ͂Ȃ
//  NX^̃CX^X葱֐ŐĈ߂lɂ͂Ȃ
//-----------------------------------------------------------------------------
function StringToMemStream(AText: string; ADstStream: TMemoryStream): Boolean;
begin
  ADstStream.Size := Length(AText) * SizeOf(Char);
  if ADstStream.Size > 0 then begin
    Move(AText[1], ADstStream.Memory^, ADstStream.Size);
  end;
  Result := ADstStream.Size > 0;
end;

//-----------------------------------------------------------------------------
//  Xg[̃f[^ String ^̕ϐɑ֐
//-----------------------------------------------------------------------------
function MemStreamToString(ASrcStream: TMemoryStream): string;
begin
  Result := '';
  if ASrcStream.Size = 0 then Exit;

  SetLength(Result, ASrcStream.Size div SizeOf(Char));
  Move(ASrcStream.Memory^, Result[1], ASrcStream.Size);
end;

end.
