//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  LœIz^̃f[^
// 2 ̓Iz
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2020N0910 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE5(UP2) Pro VCL-32
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  plCommMem;

{$R *.dfm}

const
  MAPNAME = 'TEST_2dimDynArray-integer_MEMORY_MAPPED_FILE_NAME';
  MAPSISE = 4096 * 10000;

type
  TInteger2dimDynArray = array of array of Integer;


//=============================================================================
//  tH[̏
//  L̐
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  // \ȃTCY̋Lm
  TplCommMem.Create(MAPSISE, MAPNAME);

  Memo1.ScrollBars := ssVertical;
  Memo1.Font.Size  := 11;
  Memo1.Font.Name  := 'Courier New';
end;

//=============================================================================
//  tH[j̏
//  L̉
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  TplCommMem.Free(MAPNAME);
end;

//=============================================================================
//  LɃe[^
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
const
  LRowCount : Integer = 2;
  LColCount : Integer = 5;
var
  LSrcIntArray : TInteger2dimDynArray;
  LRow         : Integer;
  LCol         : Integer;
  LInfoArray   : TCommMemHeaderArray;
  LMemStream   : TMemoryStream;
begin
  // z̗vfݒ肵āCeXgp̃f[^zvfɑ
  SetLength(LSrcIntArray, LRowCount, LColCount);
  for LRow := 0 to LRowCount - 1 do begin
    for LCol := 0 to LColCount - 1 do begin
      LSrcIntArray[LRow][LCol] := (LRow + 1) * 1000 + (LCol + 1);
    end;
  end;

  // L̃wb_
  WriteCommMemHeader(MAPNAME, LInfoArray, 1);


  LMemStream := TMemoryStream.Create;
  try
    // Xg[ɍsƗ񐔂̒li[
    LMemStream.WriteData(LRowCount);
    LMemStream.WriteData(LColCount);

    // Xg[ɔzf[^i[
    // Iz̊es̓|C^Ȃ̂Ŋes̍ŏ̗vf̃AhXw肷
    for LRow := 0 to LRowCount - 1 do begin
      LMemStream.Write(@LSrcIntArray[LRow][0], LColCount * SizeOf(Integer));
    end;

    // z̍sƗ񐔂Ɨvf̃f[^i[Xg[Lɏ
    WriteCommMemData(MAPNAME, LMemStream, LInfoArray, '2dimDynArray-integer');
  finally
    FreeAndNil(LMemStream);
  end;
end;

//=============================================================================
//  Lf[^擾
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
var
  LDataCount   : Cardinal;
  LInfoArray   : TCommMemHeaderArray;
  LMemStream   : TMemoryStream;
  LDataType    : string;
  LDstIntArray : TInteger2dimDynArray;
  LRowCount    : Integer;
  LColCount    : Integer;
  LRow         : Integer;
  LCol         : Integer;
  LResText     : string;
begin
  Memo1.Lines.Clear;

  // L̃wb_擾
  if not ReadCommMemHeader(MAPNAME, LInfoArray, LDataCount) then Exit;
  if (LDataCount = 0) then Exit;


  LMemStream := TMemoryStream.Create;
  try
    // L̃f[^Xg[ɓǂݏo
    ReadCommMemData(MAPNAME, LMemStream, LInfoArray, 0, LDataType);

    if LDataType = '2dimDynArray-integer' then begin
      LMemStream.Position := 0;
      // z̍sƗ񐔂̒lXg[ǂݏo
      LMemStream.ReadData(LRowCount);
      LMemStream.ReadData(LColCount);  
      // z̍sƗ񐔂ݒ (zp̃̊m)
      SetLength(LDstIntArray, LRowCount, LColCount);
      
      // Xg[̃f[^zvfɓǂݍ
      // Iz̊es̓|C^Ȃ̂ŁCes̐擪vfw肵čsPʂœǂݍ
      for LRow := 0 to LRowCount - 1 do begin
        LMemStream.Read(LDstIntArray[LRow][0], LColCount * SizeOf(Integer));
      end;

      // 擾f[^\
      for LRow := 0 to LRowCount - 1 do begin
        LResText := '';
        for LCol := 0 to LColCount - 1 do begin
          LResText := LResText + FormatFloat('   0000', LDstIntArray[LRow][LCol]);
        end;
        Memo1.Lines.Add(LResText);
      end;
    end;
  finally
    FreeAndNil(LMemStream);
  end;
end;

end.
